#ifndef _DB_SQL_EDITOR_H_
#define _DB_SQL_EDITOR_H_


#include "sqlide_public_interface.h"
#include "grt_manager.h"
#include "cppdbc.h"
#include "sql_editor_be.h"
#include "grts/structs.workbench.h"
#include "grts/structs.db.mgmt.h"


class Recordset;


class SQLIDE_PUBLIC_FUNC Db_sql_editor
{
public:
  Db_sql_editor(bec::GRTManager *grtm);
  virtual ~Db_sql_editor();

  db_mgmt_ConnectionRef stored_connection();
  void stored_connection(db_mgmt_ConnectionRef val);
  db_mgmt_RdbmsRef rdbms();
  Sql_editor * sql_editor();

  void reset();
  void exec_sql(const std::string &sql);
  int recordset_count();
  Recordset * recordset(int index);

private:
  void connect();

private:
  bec::GRTManager *_grtm;
  db_mgmt_ConnectionRef _stored_connection;
  std::auto_ptr<Sql_editor> _sql_editor;
  std::auto_ptr<sql::Connection> _dbc_conn;
  std::vector<Recordset*> _recordsets;
};


#endif /* _DB_SQL_EDITOR_H_ */
