#ifndef __ROUTINE_EDITOR_H__
#define __ROUTINE_EDITOR_H__

#include "DBObjectEditorBE.h"
#include "GrtTemplates.h"
#include "editor_routine.h"

#pragma make_public(::bec::RoutineEditorBE)

namespace MySQL {
namespace Grt {
namespace Db {

public ref class RoutineEditorBE : public DBObjectEditorBE
{
protected:
  RoutineEditorBE(::bec::RoutineEditorBE *inn)
    : DBObjectEditorBE(inn)
  {}

public:
  ::bec::RoutineEditorBE *get_unmanaged_object()
  { return static_cast<::bec::RoutineEditorBE *>(inner); }
  
  String^ get_sql()
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_sql().c_str());
  }

  void set_sql(String ^query)
  {
    char *c_str = GrtUtil::StringToChar(query);
    get_unmanaged_object()->set_sql(c_str);
    delete []c_str;
  }

  String^ get_name()
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_name().c_str());
  }

  void set_name(String ^query)
  {
    char *c_str = GrtUtil::StringToChar(query);
    get_unmanaged_object()->set_name(c_str);
    delete []c_str;
  }

  String^ get_comment()
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_comment().c_str());
  }

  void set_comment(String ^query)
  {
    char *c_str = GrtUtil::StringToChar(query);
    get_unmanaged_object()->set_comment(c_str);
    delete []c_str;
  }

  bool has_syntax_error() { return get_unmanaged_object()->has_syntax_error(); }
};

} // namespace Db
} // namespace Grt
} // namespace MySQL

#endif // __ROUTINE_EDITOR_H__