#ifndef __ROUTINE_GROUP_EDITOR_H__
#define __ROUTINE_GROUP_EDITOR_H__

#include "DBObjectEditorBE.h"
#include "GrtTemplates.h"
#include "editor_routinegroup.h"

#pragma make_public(::bec::RoutineGroupEditorBE)

namespace MySQL {
namespace Grt {
namespace Db {

public ref class RoutineGroupEditorBE : public DBObjectEditorBE
{
protected:
  RoutineGroupEditorBE(::bec::RoutineGroupEditorBE *inn)
    : DBObjectEditorBE(inn)
  {}

public:
  ::bec::RoutineGroupEditorBE *get_unmanaged_object()
  { return static_cast<::bec::RoutineGroupEditorBE *>(inner); }
  
  String^ get_routines_sql()
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_routines_sql().c_str());
  }

  String^ get_routine_sql(MySQL::Grt::GrtValue^ routine)
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_routine_sql(db_RoutineRef::cast_from(routine->get_unmanaged_object())).c_str());
  }

  void set_routines_sql(String ^query)
  {
    char *c_str = GrtUtil::StringToChar(query);
    get_unmanaged_object()->set_routines_sql(c_str);
    delete []c_str;
  }

  List<String^>^ get_routines_names()
  {
    return MySQL::Grt::CppStringListToNative(get_unmanaged_object()->get_routines_names());
  }

  void delete_routine_with_name(String^ name)
  {
    char *c_str = GrtUtil::StringToChar(name);
    get_unmanaged_object()->delete_routine_with_name(c_str);
    delete []c_str;
  }

  void append_routine_with_id(String^ id)
  {
    char *c_str = GrtUtil::StringToChar(id);
    get_unmanaged_object()->append_routine_with_id(c_str);
    delete []c_str;
  }

  String^ get_routine_name(String^ id)
  {
    char *c_str = GrtUtil::StringToChar(id);
    std::string name= get_unmanaged_object()->get_routine_name(c_str);
    delete []c_str;

    return GrtUtil::CharToString(name.c_str()); 
  }

  String^ get_name()
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_name().c_str());
  }

  void set_name(String ^query)
  {
    char *c_str = GrtUtil::StringToChar(query);
    get_unmanaged_object()->set_name(c_str);
    delete []c_str;
  }

  String^ get_comment()
  {
    return GrtUtil::CharToString(get_unmanaged_object()->get_comment().c_str());
  }

  void set_comment(String ^query)
  {
    char *c_str = GrtUtil::StringToChar(query);
    get_unmanaged_object()->set_comment(c_str);
    delete []c_str;
  }

  bool has_syntax_error() { return get_unmanaged_object()->has_syntax_error(); }
};

} // namespace Db
} // namespace Grt
} // namespace MySQL

#endif // __ROUTINE_GROUP_EDITOR_H__