#ifndef _GTK_HELPERS_H_
#define _GTK_HELPERS_H_

#include <gtkmm.h>
#include <vector>
#include <string>

Gtk::HBox &create_icon_label(const std::string &icon, const std::string &label);

void open_url(const std::string &url);

Glib::RefPtr<Gtk::ListStore> model_from_string_list(const std::vector<std::string>& list);
void recreate_model_from_string_list(Glib::RefPtr<Gtk::ListStore>, const std::vector<std::string>& list);

void set_glib_string(Glib::ValueBase& value, const std::string& str);
void set_glib_int(Glib::ValueBase& value, const int i);
void set_glib_bool(Glib::ValueBase& value, const bool b);
void set_glib_double(Glib::ValueBase& value, const double d);

void fill_combo_from_string_list(Gtk::ComboBoxText* combo, const std::vector<std::string>& list);
void fill_combo_from_string_list(Gtk::ComboBoxEntryText* combo, const std::vector<std::string>& list);

/*
int          item_index_in_model(Glib::RefPtr<Gtk::TreeModel> store, const std::string& item);
std::string  get_active_item_from_combo(Gtk::ComboBox* combo);
*/

#endif /* _GTK_HELPERS_H_ */
