﻿using System;
using System.Collections.Generic;
using System.Text;


namespace MySQL.Grt.Db.Sql
{
  public class SqlEditor : ScintillaNet.Scintilla
  {
    protected Sql_editor sqlEditorBE;
    GrtManager grtManager;

    public SqlEditor()
    {
    }

    public SqlEditor(GrtManager grtManager, Sql_editor sqlEditorBE)
    {
      this.grtManager = grtManager;
      this.sqlEditorBE = sqlEditorBE;
      Initialize();
    }

    public GrtManager GrtManager
    {
      get { return this.grtManager; }
      set { this.grtManager = value; }
    }

    public Sql_editor SqlEditorBE
    {
      get { return this.sqlEditorBE; }
      set { this.sqlEditorBE = value; }
    }

    public virtual void Initialize()
    {
      BeginInit();

      Dock = System.Windows.Forms.DockStyle.Fill;
      Printing.PageSettings.Color = false;
      UseFont = true;
      //DocumentChange += new System.EventHandler<ScintillaNet.NativeScintillaEventArgs>(sqlEditorControl_Change);
      Font = grtManager.get_font_option("workbench.general.Editor:Font");
      Margins.Margin0.Width = 35;
      ConfigurationManager.UseXmlReader = true;
      EndOfLine.Mode = ScintillaNet.EndOfLineMode.LF;
      Indentation.BackspaceUnindents = true;
      Indentation.ShowGuides = true;
      Indentation.SmartIndentType = ScintillaNet.SmartIndent.Simple;
      IsBraceMatching = true;

      // customized parameters
      ConfigurationManager.Language = sqlEditorBE.string_option("ConfigurationManager.Language");
      Indentation.IndentWidth = sqlEditorBE.int_option("Indentation.IndentWidth");
      Indentation.TabWidth = sqlEditorBE.int_option("Indentation.TabWidth");
      Indentation.UseTabs = sqlEditorBE.int_option("Indentation.UseTabs") != 0;
      //! todo: virtualize the rest params

      NativeInterface.SetCodePage((int)ScintillaNet.Constants.SC_CP_UTF8);

      EndInit();
    }
  }
}
