#ifndef _MFORMS_RADIOBUTTON_H_
#define _MFORMS_RADIOBUTTON_H_

#include <mforms/base.h>
#include <mforms/view.h>


namespace mforms {
  
  class RadioButton;

  struct RadioButtonImplPtrs
  {
    bool (__stdcall *create)(RadioButton *self);
    void (__stdcall *set_text)(RadioButton *self, const std::string &text);
    void (__stdcall *set_active)(RadioButton *self, bool flag);
    bool (__stdcall *get_active)(RadioButton *self);
  };
  
  class RadioButton : public View
  {
  protected:
    RadioButtonImplPtrs *_radio_impl;

    sigc::signal<void> _signal_toggled;

  public:
    RadioButton();

    void set_text(const std::string &text);
    void set_active(bool flag);
    bool get_active();

    sigc::signal<void> signal_toggled() { return _signal_toggled; }

    void callback();
  };
};

#endif
