#ifndef _WF_BUTTON_H_
#define _WF_BUTTON_H_


#include "mforms/button.h"

#include "wf_view.h"


using namespace System;
using namespace Windows::Forms;


namespace MySQL {
  namespace Forms {

    public ref class ButtonImpl : public ViewImpl
    {
    protected:
      ButtonImpl(::mforms::Button *self)
        : ViewImpl(self)
      {
      }

      static bool create(::mforms::Button *self)
      {
        ButtonImpl ^button= gcnew ButtonImpl(self);

        if (button != nullptr)
        {
          Windows::Forms::Button ^b= gcnew Windows::Forms::Button();
          button->wcontrol= b;

          b->UseMnemonic= true;

          b->Margin.All= 0;
          b->Padding.All= 0;

          b->Tag= gcnew IntPtr(self);

          b->Click += gcnew System::EventHandler(&ButtonImpl::button_click);
          return true;
        }
        return false;
      }

      static void set_text(::mforms::Button *self, const std::string &text)
      {
        ButtonImpl^ button= (ButtonImpl^)ObjectImpl::FromUnmanaged(self);

        if (button != nullptr)
        {
          std::string tmp;
        
          if (text.find('_') != std::string::npos)
          {
            tmp.append(text.substr(0, text.find('_')));
            tmp.append("&");
            tmp.append(text.substr(text.find('_')+1));
          }
          else
            tmp= text;

          button->wcontrol->Text= CppStringToNative(tmp);
          //button->wcontrol->PreferredSize.Width= button->wcontrol->GetPreferredSize(Drawing::Size(0, 0)).Width;
        }
      }

      static void button_click(System::Object ^sender, System::EventArgs ^e)
      {
        Windows::Forms::Button^ btn= (Windows::Forms::Button^)sender;

        if (btn->Tag != nullptr)
        {
          ::mforms::Button* button= reinterpret_cast<::mforms::Button*>(((IntPtr^)btn->Tag)->ToPointer());
          if (button != 0)
            button->callback();
        }
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::Button*, mgr, f->_button_impl, ButtonImpl, create);
        DEF_CALLBACK2(void, ::mforms::Button*, const std::string&, mgr, f->_button_impl, ButtonImpl, set_text);
      }
    };

  };
};


#endif
