#ifndef _WF_PANEL_H_
#define _WF_PANEL_H_


#include "mforms/panel.h"

#include "wf_view.h"

using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class PanelImpl : public ViewImpl
    {
      ::mforms::View *_child;
      bool _bordered;

    protected:
      PanelImpl(::mforms::Panel *self)
        : ViewImpl(self)
      {
      }

      static bool create(::mforms::Panel *self, bool bordered)
      {
        PanelImpl ^panel= gcnew PanelImpl(self);

        if (panel != nullptr)
        {
          panel->_bordered= bordered;
          if (bordered)
          {
            Windows::Forms::GroupBox ^l= gcnew Windows::Forms::GroupBox();
            panel->wcontrol= l;
          }
          else
          {
            panel->wcontrol= gcnew Windows::Forms::Panel();
          }
          panel->wcontrol->Margin.All= 0;
          panel->wcontrol->Padding.All= 0;
          panel->wcontrol->AutoSize= true;
          //panel->wcontrol->AutoSizeMode= AutoSizeMode::GrowAndShrink;
          return true;
        }
        return false;
      }

      static void set_title(::mforms::Panel *self, const std::string &title)
      {
        PanelImpl^ panel= (PanelImpl^)ObjectImpl::FromUnmanaged(self);

        if (panel != nullptr)
        {
          if (panel->_bordered)
            ((GroupBox^)panel->wcontrol)->Text= CppStringToNative(title);
        }
      }

      static void set_back_color(::mforms::Panel *self, const std::string &color)
      {
        PanelImpl^ panel= (PanelImpl^)ObjectImpl::FromUnmanaged(self);

        if (panel != nullptr)
        {
          if (panel->_bordered)
            ((GroupBox^)panel->wcontrol)->BackColor= System::Drawing::ColorTranslator::FromHtml(CppStringToNative(color));
          else
            ((Panel^)panel->wcontrol)->BackColor= System::Drawing::ColorTranslator::FromHtml(CppStringToNative(color));
        }
      }

      static void add(::mforms::Panel *self, ::mforms::View *view)
      {
        PanelImpl^ panel= (PanelImpl^)ObjectImpl::FromUnmanaged(self);

        if (panel != nullptr)
        {
          ViewImpl^ child= (ViewImpl^)ObjectImpl::FromUnmanaged(view);
          Windows::Forms::Control^ ctl= child->get_control();

          panel->_child= view;

          ctl->Dock= DockStyle::Fill;

          panel->get_control()->BackColor= System::Drawing::Color::Beige;
          
          panel->get_control()->Controls->Add(ctl);
        }
      }

      
    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK2(bool, ::mforms::Panel*, bool, mgr, f->_panel_impl, PanelImpl, create);
        DEF_CALLBACK2(void, ::mforms::Panel*, const std::string&, mgr, f->_panel_impl, PanelImpl, set_title);
        DEF_CALLBACK2(void, ::mforms::Panel*, ::mforms::View*, mgr, f->_panel_impl, PanelImpl, add);
        DEF_CALLBACK2(void, ::mforms::Panel*, const std::string&, mgr, f->_panel_impl, PanelImpl, set_back_color);
      }
    };

  };
};


#endif
