#ifndef _WF_PROGRESSBAR_H_
#define _WF_PROGRESSBAR_H_

#include <mforms/mforms.h>

#include "wf_view.h"


using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class ProgressBarImpl : public ViewImpl
    {
      static bool create(::mforms::ProgressBar *self)
      {
        ProgressBarImpl ^cb= gcnew ProgressBarImpl(self);

        if (cb != nullptr)
        {
          Windows::Forms::ProgressBar ^pb= gcnew Windows::Forms::ProgressBar();
          cb->wcontrol= pb;
          pb->Maximum= 1000;
          pb->Minimum= 0;
          return true;
        }
        return false;
      }

      static void set_value(::mforms::ProgressBar *self, float pct)
      {
        ProgressBarImpl^ cb= (ProgressBarImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          ((ProgressBar^)cb->wcontrol)->Value= (int)(pct * 1000);
        }
      }

      ProgressBarImpl(::mforms::ProgressBar *pbar)
        : ViewImpl(pbar)
      {
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::ProgressBar*, mgr, f->_progressbar_impl, ProgressBarImpl, create);
        DEF_CALLBACK2(void, ::mforms::ProgressBar*, float, mgr, f->_progressbar_impl, ProgressBarImpl, set_value);
      }
    };

  };
};

#endif
