#ifndef _WF_TABVIEW_H_
#define _WF_TABVIEW_H_

#include "wf_view.h"

using namespace System;
using namespace System::Collections::Generic;
using namespace System::Runtime::InteropServices;

namespace MySQL
{
  namespace Forms
  {
    public ref class TabViewImpl : public ViewImpl
    {
    protected:
      TabViewImpl(::mforms::TabView *self)
        : ViewImpl(self)
      {
      }

      static bool create(::mforms::TabView *self)
      {
        TabViewImpl ^cb= gcnew TabViewImpl(self);

        if (cb != nullptr)
        {
          Windows::Forms::TabControl ^tb= gcnew Windows::Forms::TabControl();
          cb->wcontrol= tb;
          return true;
        }
        return false;
      }

      static void set_active_tab(::mforms::TabView *self, int index)
      {
        TabViewImpl^ cb= (TabViewImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          ((TabControl^)cb->wcontrol)->SelectedIndex= index;
        }
      }

      static int get_active_tab(::mforms::TabView *self)
      {
        TabViewImpl^ cb= (TabViewImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          return ((TabControl^)cb->wcontrol)->SelectedIndex;
        }
        return -1;
      }

      static int add_page(::mforms::TabView *self, ::mforms::View *page, const std::string& caption)
      {
        TabViewImpl^ cb= (TabViewImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(page);
          TabPage^ tabPage= gcnew TabPage();

          view->get_control()->Dock = DockStyle::Fill;
          tabPage->Controls->Add(view->get_control());
          tabPage->Text= CppStringToNative(caption);

          ((TabControl^)cb->wcontrol)->TabPages->Add(tabPage);

          return ((TabControl^)cb->wcontrol)->TabPages->Count-1;
        }
        return -1;
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::TabView*, mgr, f->_tabview_impl, TabViewImpl, create);
        DEF_CALLBACK1(int, ::mforms::TabView*, mgr, f->_tabview_impl, TabViewImpl, get_active_tab);
        DEF_CALLBACK2(void, ::mforms::TabView*, int, mgr, f->_tabview_impl, TabViewImpl, set_active_tab);
        DEF_CALLBACK3(int, ::mforms::TabView*, ::mforms::View*, const std::string&, mgr, f->_tabview_impl, TabViewImpl, add_page);
      }
    };
  };
};

#endif
