#ifndef _WF_TEXTENTRY_H_
#define _WF_TEXTENTRY_H_

#include <mforms/mforms.h>

#include "wf_view.h"


using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class TextEntryImpl : public ViewImpl
    {
      static bool create(::mforms::TextEntry *self)
      {
        TextEntryImpl ^cb= gcnew TextEntryImpl(self);

        if (cb != nullptr)
        {
          Windows::Forms::TextBox ^tb= gcnew Windows::Forms::TextBox();
          cb->wcontrol= tb;
          tb->Multiline= false;
          /*
          if (multiline)
          {
            tb->AcceptsReturn= true;
            tb->ScrollBars= ScrollBars::Both;
          }*/
          return true;
        }
        return false;
      }

      static void set_text(::mforms::TextEntry *self, const std::string &text)
      {
        TextEntryImpl^ cb= (TextEntryImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          ((TextBox^)cb->wcontrol)->Text= CppStringToNative(text);
        }
      }

      static std::string get_text(::mforms::TextEntry *self)
      {
        TextEntryImpl^ cb= (TextEntryImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          return NativeToCppString(((TextBox^)cb->wcontrol)->Text);
        }
        return "";
      }

      TextEntryImpl(::mforms::TextEntry *text)
        : ViewImpl(text)
      {
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::TextEntry*, mgr, f->_textentry_impl, TextEntryImpl, create);
        DEF_CALLBACK2(void, ::mforms::TextEntry*, const std::string&, mgr, f->_textentry_impl, TextEntryImpl, set_text);
        DEF_CALLBACK1(std::string, ::mforms::TextEntry*, mgr, f->_textentry_impl, TextEntryImpl, get_text);
      }
    };

  };
};

#endif
