#include "stdafx.h"

#include <vcclr.h>
#include <windows.h>

#include "wf_mforms.h"


static char* StringToChar(String^ str)
{
  if (!str)
    return NULL;

  // Pin memory so GC can't move it while native function is called
  pin_ptr<const wchar_t> wch = PtrToStringChars(str);

  // Conversion to char* :
  // Can just convert wchar_t* to char* using one of the 
  // conversion functions such as: 
  // WideCharToMultiByte()
  // wcstombs_s()
  // ... etc

  int sizeInBytes = ((str->Length + 1) * 4); // utf8 can have up to 4 bytes per char (not 2)
  errno_t err = 0;
  char    *ch = new char[sizeInBytes];

  size_t convertedChars = WideCharToMultiByte(CP_UTF8, 0, wch, -1, ch, sizeInBytes, 0, 0);
  //if (err != 0)
  //  throw ...

  // compress \r\n to \n
  char *from, *to;

  for (from= to= ch; *from != '\0'; ++from, ++to)
  {
    if (*from == '\r' && *(from+1)=='\n')
      ++from;
    *to= *from;
  }
  *to= 0;

  return ch;
}


static String^ CharToString(const char *str, size_t length)
{
  // TODO optimize here - do not copy string creating std::string
  std::string res= str;//bec::replace_string(str, "\n", "\r\n");

  // TODO is there a faster way to cache this encoding obj?
  return gcnew String(res.c_str(), 0, (int) res.size(), gcnew System::Text::UTF8Encoding(true, true));
}


String^ MySQL::CppStringToNative(const std::string &input)
{
  return CharToString(input.c_str(), input.size());
}

std::string MySQL::NativeToCppString(String^ input)
{
  char *c_str= StringToChar(input);
  std::string result= c_str;
  delete[] c_str;
  return result;
}
