#ifndef _WF_VIEW_H_
#define _WF_VIEW_H_

#include <mforms/mforms.h>


#include "wf_base.h"
#include "wf_mforms.h"

using namespace System;
using namespace Windows::Forms;


namespace MySQL {
  namespace Forms {

    public ref class ViewImpl : public ObjectImpl
    {
    protected:
      Windows::Forms::Control ^wcontrol;

      ViewImpl(::mforms::View *view)
        : ObjectImpl(view)
      {
      }

      static void show(::mforms::View *self, bool show)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);

        if (view != nullptr)
        {
          if (show)
            ((Control^)view->wcontrol)->Show();
          else
            ((Control^)view->wcontrol)->Hide();
        }
      }
      
      static int get_width(::mforms::View *self)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          return view->wcontrol->Width;
        }
        return 0;
      }

      static int get_height(::mforms::View *self)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          return view->wcontrol->Height;
        }
        return 0;
      }

      static int get_preferred_width(::mforms::View *self)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          return 0;//view->calc_preferred_width();
        }
        return 0;
      }

      static int get_preferred_height(::mforms::View *self)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          return 0;//view->calc_preferred_height();
        }
        return 0;
      }

      static int get_x(::mforms::View *self)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          return view->wcontrol->Left;
        }
        return 0;
      }

      static int get_y(::mforms::View *self)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          return view->wcontrol->Top;
        }
        return 0;
      }
      
      static void set_size(::mforms::View *self, int w, int h)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          view->set_size(w, h);
        }
      }

      static void set_position(::mforms::View *self, int x, int y)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          view->wcontrol->Top= y;
          view->wcontrol->Left= x;
        }
      }

      static void set_enabled(::mforms::View *self, bool flag)
      {
        ViewImpl^ view= (ViewImpl^)ObjectImpl::FromUnmanaged(self);
        if (view != nullptr)
        {
          view->wcontrol->Enabled= flag;
        }
      }

      static View *find_subview(::mforms::View *self, const std::string &name)
      {
        return 0;
      }



      virtual void set_size(int width, int height)
      {
        if (width > 0)
        {
          wcontrol->Width= width;
          wcontrol->MinimumSize.Width= width;
        }
        if (height > 0)
        {
          wcontrol->Height= height;
          wcontrol->MinimumSize.Height= height;
        }
      }


    public:

      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(int, ::mforms::View*, mgr, f->_view_impl, ViewImpl, get_x);
        DEF_CALLBACK1(int, ::mforms::View*, mgr, f->_view_impl, ViewImpl, get_y);
        DEF_CALLBACK1(int, ::mforms::View*, mgr, f->_view_impl, ViewImpl, get_width);
        DEF_CALLBACK1(int, ::mforms::View*, mgr, f->_view_impl, ViewImpl, get_height);
        DEF_CALLBACK1(int, ::mforms::View*, mgr, f->_view_impl, ViewImpl, get_preferred_width);
        DEF_CALLBACK1(int, ::mforms::View*, mgr, f->_view_impl, ViewImpl, get_preferred_height);
        DEF_CALLBACK3(void, ::mforms::View*, int, int, mgr, f->_view_impl, ViewImpl, set_position);
        DEF_CALLBACK3(void, ::mforms::View*, int, int, mgr, f->_view_impl, ViewImpl, set_size);
        DEF_CALLBACK2(void, ::mforms::View*, bool, mgr, f->_view_impl, ViewImpl, show);
        DEF_CALLBACK2(void, ::mforms::View*, bool, mgr, f->_view_impl, ViewImpl, set_enabled);
      }

      Windows::Forms::Control ^get_control() { return wcontrol; }

    };

  };
};

#endif
