#ifndef _DB_MYSQL_DIFF_REPORTING_WRAPPER_H_
#define _DB_MYSQL_DIFF_REPORTING_WRAPPER_H_

#include "db_mysql_diff_reporting.h"
#include "GrtTemplates.h"

namespace MySQL {
namespace GUI {
namespace Workbench {
namespace Plugins {
namespace DbMySQL {

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
using namespace MySQL::Grt;

public ref class DbMySQLDiffReporting //: MySQL::GUI::Workbench::Plugins::Db::Db_plugin
{
  ::DbMySQLDiffReporting *_inner;

  MySQL::GUI::Workbench::Plugins::Db::Db_plugin ^left_db, ^right_db;

public:

  DbMySQLDiffReporting(MySQL::Grt::GrtManager ^grt_manager) 
    : _inner(new ::DbMySQLDiffReporting(grt_manager->get_unmanaged_object()))
  {
    left_db= gcnew MySQL::GUI::Workbench::Plugins::Db::Db_plugin;
    right_db= gcnew MySQL::GUI::Workbench::Plugins::Db::Db_plugin;
  }

  MySQL::Grt::GrtManager^ get_grt_manager() 
  { return gcnew MySQL::Grt::GrtManager(_inner->get_grt_manager()); }

  String^ generate_report(String^ left_file, 
                          String^ right_file, 
                          MySQL::Grt::GrtValue^ left_cat, 
                          MySQL::Grt::GrtValue^ right_cat)
  {
    return CppStringToNative(_inner->generate_report(
      NativeToCppString(left_file), 
      NativeToCppString(right_file),
      left_cat->get_unmanaged_object(),
      right_cat->get_unmanaged_object()));
  }

  MySQL::GUI::Workbench::Plugins::Db::Db_plugin ^get_left_db()
  { return left_db; }

  MySQL::GUI::Workbench::Plugins::Db::Db_plugin ^get_right_db()
  { return right_db; }

};

} // namespaces
}
}
}
}

#endif // _DB_MYSQL_DIFF_REPORTING_WRAPPER_H_