#ifndef __WB_MYSQL_TABLE_EDITOR_TRIGGER_PAGE_H__
#define __WB_MYSQL_TABLE_EDITOR_TRIGGER_PAGE_H__

#include <gtkmm.h>
#include "grt/tree_model.h"
#include "sql_editor_fe.h"


class MySQLTableEditorBE;
class MGGladeXML;
class ListModelWrapper;
class DbMySQLTableEditor;

//==============================================================================
//
//==============================================================================
class DbMySQLTableEditorTriggerPage
{
  public:
    DbMySQLTableEditorTriggerPage(DbMySQLTableEditor *owner, MySQLTableEditorBE* be, MGGladeXML* xml);

    void refresh();
  
  private:
    bool process_event(GdkEvent* event);
    void parse_sql(const std::string& sql);
    void editor_parse_error_cb(const int lineno, const std::string& errormsg);
    void editor_parse_log_cb(const std::vector<std::string>& list);
    
    //void error_selected(const Gtk::TreeModel::Path& path, const Gtk::TreeModel::iterator& it);
    void error_selected();
    void track_pane();

    DbMySQLTableEditor                       *_owner;
    MySQLTableEditorBE                       *_be;
    MGGladeXML                               *_xml;

    //Gtk::TextView                            *_code;
    Gtk::TreeView                            *_errors_tv;
    Gtk::Paned                               *_paned;

    struct ErrorColumns : public Gtk::TreeModel::ColumnRecord
    {
      ErrorColumns()
      {
        add(lineno);
        add(msg);
      }
      
      Gtk::TreeModelColumn<int>         lineno;
      Gtk::TreeModelColumn<std::string> msg;
    };

    ErrorColumns                              _errors_columns;
    Glib::RefPtr<Gtk::ListStore>              _errors_model;
    int                                       _pane_position;
    sigc::connection                          _pane_pos_changed_conn;

    SqlEditorFE                               _trigger_code;
};

#endif
