#ifndef __DB_CONN_WR_H__
#define __DB_CONN_WR_H__


#include "db_conn_be.h"
#include "GrtTemplates.h"


namespace MySQL {
namespace CppDBC {


using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;
using namespace MySQL::Grt;

public ref class Db_conn
{
private:
  ::Db_conn *_inner;
  bool _is_inner_owner;
  ComboBox ^_drivers_cb;
  int _rdbms_index;
  int _driver_index;
  ComboBox ^_databases_cb;
  ComboBox ^_stored_connections_cb;
  Panel ^_common_params_panel;
  Panel ^_advanced_params_panel;

  delegate void Void_void_handler();

  Void_void_handler ^_clear_param_controls;
  void clear_param_controls();
  void suspend_controls_layout();
  void resume_controls_layout();

  KeyPressEventHandler ^_handle_int_param_key_press;
  void handle_int_param_key_press(Object ^sender, KeyPressEventArgs ^e);

  delegate void Create_control(Db_driver_param *driver_param, Control_type ctrl_type, Position &pos, Size &size, const std::string *caption);
  Create_control ^_create_control;
  void create_control(Db_driver_param *driver_param, Control_type ctrl_type, Position &pos, Size &size, const std::string *caption);

  delegate void Set_combobox_lov(::grt::StringListRef *lov, int combobox_index);
  Set_combobox_lov ^_set_combobox_lov;
  void set_combobox_lov(grt::StringListRef *lov, int combobox_index);

  int get_default_rdbms_index() { return _inner->get_default_rdbms_index(); }
  void set_active_rdbms(int rdbms_index,
                        int driver_index,
                        int stored_conn_index,
                        bool reset_stored_conn_selection);

  int get_rdbms_default_driver_index() { return _inner->get_rdbms_default_driver_index(); }
  void set_active_driver(int driver_index,
                         int stored_conn_index,
                         bool reset_stored_conn_selection);

  EventHandler ^_change_active_rdbms;
  void change_active_rdbms(Object ^sender, EventArgs ^e);

  EventHandler ^_change_active_driver;
  void change_active_driver(Object ^sender, EventArgs ^e);

  EventHandler ^_change_active_param;
  void change_active_param(Object ^sender, EventArgs ^e);

  EventHandler ^_change_active_stored_conn;
  void change_active_stored_conn(Object ^sender, EventArgs ^e);

  void reset_stored_conn_list();
  void set_active_stored_conn(int stored_conn_index);

public:
  Db_conn(::Db_conn *inner);
  virtual ~Db_conn() { this->!Db_conn(); }
  !Db_conn();

  void init(ComboBox ^databases_cb,
            ComboBox ^drivers_cb,
            ComboBox ^stored_connections_cb,
            Panel ^common_params_panel,
            Panel ^advanced_params_panel);
  void set_rdbms_list();
  void add_stored_conn(String ^name);
  void remove_stored_conn(int stored_conn_index);
  void reset_connection_params() { set_active_stored_conn(-1); }
  String ^ validate_driver_params() { return CppStringToNative(_inner->validate_driver_params()); }
  void test_connection();
};


};  // namespace CppDBC
};  // namespace MySQL

#endif // __DB_CONN_WR_H__
