#ifndef _WB_MODEL_REPORTING_WRAPPER_H_
#define _WB_MODEL_REPORTING_WRAPPER_H_

#include "wb_model_reporting.h"
#include "GrtTemplates.h"

namespace MySQL {
namespace GUI {
namespace Workbench {
namespace Plugins {
namespace WbModelReporting {

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
using namespace MySQL::Grt;


public ref class WbModelReporting
{
  ::WbModelReporting *_inner;

public:

  WbModelReporting(MySQL::Grt::GrtManager ^grt_manager) 
    : _inner(new ::WbModelReporting(grt_manager->get_unmanaged_object()))
  {}

  //MySQL::Grt::GrtManager^ get_grt_manager() 
  //{ return gcnew MySQL::Grt::GrtManager(_inner->get_grt_manager()); }
  
  //MySQL::Grt::GrtValue^ get_catalog()
  //{ return gcnew MySQL::Grt::GrtValue(_inner->get_catalog().grt_value()); }

  //void set_option(String^ name, bool value)
  //{ _inner->set_option(NativeToCppString(name_str), value); }

  void set_option(String^ name, String^ value)
  { _inner->set_option(NativeToCppString(name), NativeToCppString(value)); }

  void start_sync()
  { _inner->start_sync(); }

  List<String^>^ get_available_reporting_templates()
  {
    return CppStringListToNative(_inner->get_available_reporting_templates());
  }

  void set_active_template(String^ template_name)
  {
    _inner->set_active_template(NativeToCppString(template_name));
  }

  List<String^>^ get_available_reporting_template_style_names()
  {
    return CppStringListToNative(_inner->get_available_reporting_template_style_names());
  }

  String^ get_reporting_template_description()
  {
    return CppStringToNative(_inner->get_reporting_template_description());
  }

  String^ get_reporting_template_main_filename()
  {
    return CppStringToNative(_inner->get_reporting_template_main_filename());
  }



  void set_active_template_style(String^ template_style_name)
  {
    _inner->set_active_template_style(NativeToCppString(template_style_name));
  }

  String^ get_reporting_template_style_description()
  {
    return CppStringToNative(_inner->get_reporting_template_style_description());
  }

  String^ get_reporting_template_style_preview_image_filename()
  {
    return CppStringToNative(_inner->get_reporting_template_style_preview_image_filename());
  }
};

} // namespaces
}
}
}
}

#endif // _WB_MODEL_REPORTING_WRAPPER_H_