#include "stdafx.h"

#include "myx_grtpp.h"

#include "wb_model.h"
#include "grts/structs.workbench.physical.h"
#include "grt/grt_manager.h"
#include "grt/undo_manager.h"

#include "grti/wb_model.h"


using namespace grt;


#ifdef _WIN32
# define FRONTEND_LIBNAME(obj, windows_dll, linux_so, osx_dylib)\
  obj.moduleName(windows_dll)
#elif defined(__APPLE__)
# define FRONTEND_LIBNAME(obj, windows_dll, linux_so, osx_dylib)\
  obj.moduleName(osx_dylib)
#else
# define FRONTEND_LIBNAME(obj, windows_dll, linux_so, osx_dylib)\
  obj.moduleName(linux_so)
#endif


// not used --alfredo
#if 0


GRT_MODULE_ENTRY_POINT(WBModelImpl);


#define def_export_view_plugin(aName, aCaption)\
  {\
    app_Plugin plugin(get_grt());\
    app_PluginObjectInput pdef(get_grt());\
    plugin.name("wb.model."aName);\
    plugin.caption(aCaption);\
    plugin.moduleName("WBModel");\
    plugin.moduleFunctionName(aName);\
    plugin.pluginType("normal");\
    plugin.rating(100);\
    plugin.showProgress(1);\
    pdef.name("activeView");\
    pdef.objectStructName("model.View");\
    pdef.owner(plugin);\
    plugin.inputValues().insert(pdef);\
    plugin.groups().insert("Application/Workbench");\
    list.insert(plugin);\
  }


#define def_export_catalog_plugin(aName, aCaption)\
  {\
    app_Plugin plugin(get_grt());\
    app_PluginObjectInput pdef(get_grt());\
    plugin.name("wb.model."aName);\
    plugin.caption(aCaption);\
    plugin.moduleName("WBModel");\
    plugin.moduleFunctionName(aName);\
    plugin.pluginType("normal");\
    plugin.rating(100);\
    plugin.showProgress(1);\
    pdef.name("activeCatalog");\
    pdef.objectStructName("db.Catalog");\
    pdef.owner(plugin);\
    plugin.inputValues().insert(pdef);\
    plugin.groups().insert("database/Database");\
    list.insert(plugin);\
  }


ListValue<app_Plugin> WBModelImpl::getPluginInfo()
{
  ListValue<app_Plugin> list(get_grt());

  def_export_view_plugin("autolayout", "Autolayout Figures");
//XXX must be fixed  def_export_catalog_plugin("autoplace", "Autoplace Objects of the Catalog on New Model");

  return list;
}

template <typename T>
T * WBModelImpl::get_module_interface(const char *module_name)
{
  return static_cast<T *>(_grt->get_module(module_name));
}


#define GET_MODULE_INTERFACE(var, module_class, module_interface_class) \
  module_interface_class *var= get_module_interface<module_interface_class>(module_class); \
  if (!var) \
    return 1;


int WBModelImpl::autolayout(model_View view)
{
  GET_MODULE_INTERFACE(module, "WbModel", WbModelWbmI)
  return module->autolayout(view);
}


int WBModelImpl::autoplace(db_Catalog catalog, grt::DictValue options)
{
  GET_MODULE_INTERFACE(module, "WbModel", WbModelWbmI)
  return module->autoplace(catalog, options);
}

#endif
