
-- 
-- returns reference to the global catalog object
--

function wb_catalog()
	return grtV.getGlobal("/wb/doc/physicalModels/0/catalog")
end

-- 
-- returns reference to the global list of schemata
--

function wb_schemata()
	return wb_catalog().schemata
end

-- 
-- returns reference to the schema with given name or nil
-- @param name schema name
--

function wb_schema_with_name(name)

	schemata = grtV.toLua(wb_schemata())
	for i, schema in ipairs(schemata) do
		if schema.name == name then
			return schema
		end
	end
	
	return nil
end

-- 
-- returns reference to the list of tablea for the schema 
-- with given name or nil
-- @param name schema name
--

function wb_tables_of_schema(name)
	schema = wb_schema_with_name(name)
	if schema == nil then
		return nil
	end
	return schema.tables
end

-- 
-- returns reference to the list of views for the schema 
-- with given name or nil
-- @param name schema name
--

function wb_views_of_schema(name)
	schema = wb_schema_with_name(name)
	if schema == nil then
		return nil
	end
	return schema.views
end

-- 
-- returns reference to the list of routines for the schema 
-- with given name or nil
-- @param name schema name
--

function wb_routines_of_schema(name)
	schema = wb_schema_with_name(name)
	if schema == nil then
		return nil
	end
	return schema.routines
end
