#ifndef __GRT_TEST_UTILITY_H__
#define __GRT_TEST_UTILITY_H__

#include "tut.h"
#include "grtpp.h"

using namespace grt;

std::string format_msg(const char* major_msg, const char* minor_msg= NULL, grt::Type grt_type= AnyType, int item_index= -1);
std::string grt_type_to_str(grt::Type grt_type);

template <class G, class S>
ListRef<G> list_from_array(GRT &grt, S *varr, size_t varr_size)
{
  ListRef<G> list(&grt);
  for (unsigned n= 0; n<varr_size; n++)
    list.insert(varr[n]);
  return list;
}

template <class G, class S>
DictRef dict_from_array(GRT &grt, std::string *keys, S *varr, size_t varr_size)
{
  DictRef dict(&grt);
  for (unsigned n= 0; n<varr_size; n++)
    dict.set(keys[n], G(varr[n]));
  return dict;
}

void grt_ensure_equals(
  const char* major_msg,
  const ValueRef& res_val,
  const ValueRef& test_val,
  bool compare_obj_id= false,
  int item_index= -1,
  std::list<std::string> *followed_obj_stack= NULL);

void check_module_function_return(
  Module *test_module,
  const char *func_name,
  BaseListRef &args,
  const ValueRef &test_val,
  bool compare_obj_id= false);




void dump_tree_model(const std::string &path, bec::TreeModel *tree, const std::vector<int> &columns);


#endif // __GRT_TEST_UTILITY_H__
